/************

This is a slightly more complicated demo, showing the use
of setting object colors and call-back routines.

Written by Mark Overmars

Date: 29 Apr 1991

************/

#include <stdio.h>
#include "forms.h"

FL_FORM *form;
FL_OBJECT *topbox;

void change_color(FL_OBJECT *obj, long col)
  { fl_set_object_color(topbox, (int) col, (int) col); }

void makeform()
{
  FL_OBJECT *obj;
  int i,j;
  char str[100];
  form = fl_bgn_form(FL_UP_BOX,100.0,100.0);
    for (i=0; i<8; i++) for (j=0; j<8; j++)
      {
        sprintf(str,"%d",8*j+i);
        obj = fl_add_button(FL_RADIO_BUTTON,11.0+10.0*i,75.0-10.0*j,8.0,6.0,str);
        fl_set_object_color(obj,8*j+i,8*j+i);
        fl_set_object_align(obj,FL_ALIGN_BOTTOM);
        fl_set_call_back(obj,change_color, (long) (8*j+i));
      }
    topbox = fl_add_button(FL_NORMAL_BUTTON,30.0,85.0,40.0,8.0,"The Color Map");
    fl_set_object_lsize(topbox,FL_LARGE_FONT);
    fl_set_object_lstyle(topbox,FL_BOLD_STYLE);
  fl_end_form();
}

main()
{
  FL_OBJECT *ret;
  fl_init();
  fl_set_graphics_mode(0,0);
  makeform();
  fl_show_form(form,FL_PLACE_FREE,FALSE,NULL);
  do ret = fl_do_forms(); while (ret != topbox);
  fl_hide_form(form);
}
